结题报告 HDU-3535

HDU - 3535 Are you busy(混合背包)

Problem Description:
Happy New Term!
As having become a junior, xiaoA recognizes that there is not much time for her to AC problems, because there are some other things for her to do, which makes her nearly mad.
What’s more, her boss tells her that for some sets of duties, she must choose at least one job to do, but for some sets of things, she can only choose at most one to do, which is meaningless to the boss. And for others, she can do of her will. We just define the things that she can choose as “jobs”. A job takes time , and gives xiaoA some points of happiness (which means that she is always willing to do the jobs).So can you choose the best sets of them to give her the maximum points of happiness and also to be a good junior(which means that she should follow the boss’s advice)?

input:
There are several test cases, each test case begins with two integers n and T (0<=n,T<=100) , n sets of jobs for you to choose and T minutes for her to do them. Follows are n sets of description, each of which starts with two integers m and s (0<m<=100), there are m jobs in this set , and the set type is s, (0 stands for the sets that should choose at least 1 job to do, 1 for the sets that should choose at most 1 , and 2 for the one you can choose freely).then m pairs of integers ci,gi follows (0<=ci,gi<=100), means the ith job cost ci minutes to finish and gi points of happiness can be gained by finishing it. One job can be done only once.

output:
One line for each test case contains the maximum points of happiness we can choose from all jobs .if she can’t finish what her boss want, just output -1 .

Sample Input:
3 3
2 1
2 5
3 8
2 0
1 0
2 1
3 2
4 3
2 1
1 1
3 4
2 1
2 5
3 8
2 0
1 1
2 8
3 2
4 4
2 1
1 1
1 1
1 0
2 1
5 3
2 0
1 0
2 1
2 0
2 2
1 1
2 0
3 2
2 1
2 1
1 5
2 8
3 2
3 8
4 9
5 10

Sample Output:
5
13
-1
-1

------------------------------分割线------------------------------
题意:给你n个工作集合,需要在T的时间内做完,一个工作集合有m件事情可以做,每个工作集合有三种属性s,分别是0,1,2;s=0说明这m件事中最少得做一件,s=1说明这m件事中最多只能做一件,s=2说明这m件事你可以做也可以不做。最后给你ci和gi,分别是需要的时间和可以获得快乐值,让你求在T的时间内可以获得最大的快乐值。
------------------------------分割线------------------------------
解析:
因为存在最优解,我可以更换做事情的顺序,即我们可以分别处理每个集合,细节dp[i]= -INF;
设dp[i][j]为做第i个集合的第j件事情的可以获得最大的快乐值。由于每个集合有三种属性,我们分类讨论:
1:若s=0,我们最少做一件事情;我们先选一个第i类集合元素,用dp[i-1],来更新dp[i],同时也可以用01背包的思想用本类的前一个事情来更新下一个事情;
状态转移方程:
dp[i][t]=max(dp[i][t],dp[i-1][t-cost[j]]+val[j],dp[i][t-cost[j]]+val[j])
2:若s=1,我们最多做一件事情,我们只能从dp[i-1]来更新。
状态转移方程:
dp[i][t] = max(dp[i][t],dp[i-1][t-cost[j]]+val[j]);
3:s = 2,说明这m件事你可以做也可以不做,那就变成了01背包问题。
状态转移方程:
dp[i][t]=max(dp[i][t],dp[i-1][t-cost[j]]+val[j],dp[i][t-cost[j]]+val[j])…
最终答案就是dp[n][T];
------------------------------分割线------------------------------
AC代码:

#include<iostream>
#include<string.h>
#include<algorithm>
#include<math.h>
#include<stack>
#include<map>
#include<queue> 
#include<vector>
#include<set>
#define ll long long 
#define INF 0x3F3F3F3F 
#define MOD 1000000007

using namespace std; 
const int MAXN=2e5+7;
int n,t,m,s;

int dp[301][301],cost[301],val[301];
void init(int i ){
	memset(dp[i],-INF,sizeof(dp[i]));
}
int main()
{
	while(cin>>n>>t){
		memset(dp,0,sizeof(dp));
 
        for(int i=1;i<=n;i++)
        {
            cin>>m>>s;
            for(int k=1;k<=m;k++)
                cin>>cost[k]>>val[k];
 
            if(s==0)
            {
                for(int j=0;j<=t;j++) dp[i][j]=-INF;
                for(int k=1;k<=m;k++)
                for(int j=t;j>=cost[k];j--)
                {
                    dp[i][j] = max( dp[i][j] , dp[i][j-cost[k]]+val[k] ); 
                    dp[i][j] = max( dp[i][j] , dp[i-1][j-cost[k]]+val[k] );
                    
                }
            }
            else if(s==1)
            {
                for(int j=0;j<=t;j++) dp[i][j]=dp[i-1][j];
 
                for(int k=1;k<=m;k++)
                for(int j=t;j>=cost[k];j--)
                    dp[i][j] = max( dp[i][j] , dp[i-1][j-cost[k]]+val[k] );
            }
            else if(s==2)
            {
                for(int j=0;j<=t;j++) dp[i][j]=dp[i-1][j];
 
                for(int k=1;k<=m;k++)
                for(int j=t;j>=cost[k];j--)
                    dp[i][j] = max( dp[i][j] , dp[i][j-cost[k]]+val[k] );
            }
        }
        int ans = max(dp[n][t],-1);
        cout<<ans<<endl;
    }

	return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值